from __future__ import (absolute_import, division,print_function)
import maya.cmds as cmds
from .. import rigSettings,rigUtil

_MODULETYPE = "ctrl"

##アトリビュート名リスト
_ATTRS = [
        
]

##アトリビュートのタイプ　デフォルト値などオプションを定義
_ATTR_DICT = {

}


##セットアップ実行用
def main(**kwargs):
    ctrlSize = kwargs["globalScale"]

    ##create structure
    cmds.createNode("transform", name = rigSettings.NODENAME_DICT["rootGP"])
    cmds.createNode("transform", name = rigSettings.NODENAME_DICT["ctrlGP"], p = rigSettings.NODENAME_DICT["rootGP"])
    cmds.createNode("transform", name = rigSettings.NODENAME_DICT["jointGP"], p = rigSettings.NODENAME_DICT["rootGP"])
    cmds.createNode("transform", name = rigSettings.NODENAME_DICT["setupGP"], p = rigSettings.NODENAME_DICT["rootGP"])
    cmds.createNode("transform", name = rigSettings.NODENAME_DICT["modelGP"], p = rigSettings.NODENAME_DICT["rootGP"])

    ##全体移動コントローラーの作成
    rigUtil.createCtrlNode(rigSettings.NODENAME_DICT["allCtrl"],"circle_y","joint",     size = ctrlSize*1.4,position = None,rotation =None)
    rigUtil.createCtrlNode(rigSettings.NODENAME_DICT["subCtrl"],"circle_y","joint",     size = ctrlSize*1.2,position = None,rotation =None)
    rigUtil.createCtrlNode(rigSettings.NODENAME_DICT["scaleCtrl"],"circle_y","joint",   size = ctrlSize,position = None,rotation =None)

    cmds.createNode("transform", name = rigSettings.NODENAME_DICT["ctrlWorldSpace"])

    cmds.parent(rigSettings.NODENAME_DICT["allCtrl"],rigSettings.NODENAME_DICT["ctrlGP"],a =True)
    cmds.parent(rigSettings.NODENAME_DICT["subCtrl"],rigSettings.NODENAME_DICT["allCtrl"],a =True)
    cmds.parent(rigSettings.NODENAME_DICT["scaleCtrl"],rigSettings.NODENAME_DICT["subCtrl"],a =True)
    cmds.parent(rigSettings.NODENAME_DICT["ctrlWorldSpace"],rigSettings.NODENAME_DICT["scaleCtrl"],a =True)

    #postTransform_gpのセットアップ
    cmds.addAttr(rigSettings.NODENAME_DICT["scaleCtrl"], ln = "allScale", at = "double",dv = 1.0,min = 0.0001, k =True)
    cmds.addAttr(rigSettings.NODENAME_DICT["ctrlWorldSpace"], ln = "postScale", at = "double",dv = 1.0,min = 0.0001, k =False)
    
    scaleMult = cmds.createNode("floatMath")
    cmds.setAttr(scaleMult + ".operation",2)
    cmds.connectAttr(rigSettings.NODENAME_DICT["scaleCtrl"] + ".allScale", scaleMult + ".floatA")
    cmds.connectAttr(rigSettings.NODENAME_DICT["ctrlWorldSpace"] + ".postScale", scaleMult + ".floatB")
    rigUtil.connectAttrZip(scaleMult,rigSettings.NODENAME_DICT["ctrlWorldSpace"],["outFloat","outFloat","outFloat"],["scaleX","scaleY","scaleZ"],True)


    if cmds.objExists(rigSettings.NODENAME_DICT["rootJNT"]):
        cmds.parent(rigSettings.NODENAME_DICT["rootJNT"],rigSettings.NODENAME_DICT["jointGP"],a =True)

        ##connect scaleCtrl to root_jnt
        ##わかりやすくする為に parentConstraint
        cmds.parentConstraint(rigSettings.NODENAME_DICT["ctrlWorldSpace"],rigSettings.NODENAME_DICT["rootJNT"])
        rigUtil.connectAttrZip(rigSettings.NODENAME_DICT["ctrlWorldSpace"],rigSettings.NODENAME_DICT["rootJNT"],["s"],["s"],True)

        ##全体スケール対応の為rootJoint の直下のjoint.segmentScaleCompensate をオフにする
        joints = cmds.listRelatives(rigSettings.NODENAME_DICT["rootJNT"],type = "joint") or []
        for joint in joints:
            cmds.setAttr(joint + ".segmentScaleCompensate",0)

    ctrls = [
                rigSettings.NODENAME_DICT["allCtrl"],
                rigSettings.NODENAME_DICT["subCtrl"],
                rigSettings.NODENAME_DICT["scaleCtrl"]
    ]

    ##不要なアトリビュートをロック
    rigUtil.setAttrState(ctrls,["s","v"],True,True,False)
    rigUtil.setAttrState([rigSettings.NODENAME_DICT["rootGP"]],["t","r","s"],True,True,False)

    ##コントローラーの色を設定
    rigUtil.setWireFrameColor([rigSettings.NODENAME_DICT["allCtrl"]],"blue", 0.8)
    rigUtil.setWireFrameColor([rigSettings.NODENAME_DICT["subCtrl"]],"green",0.8)
    rigUtil.setWireFrameColor([rigSettings.NODENAME_DICT["scaleCtrl"]],"yellow",0.8)

    ##コントローラーを setsへ登録
    rigUtil.addToSet(rigSettings.NODENAME_DICT["allCtrlSet"],[rigSettings.NODENAME_DICT["rootGP"]])
    rigUtil.addToSet(rigSettings.NODENAME_DICT["allCtrlSet"],ctrls)
        
    return